<template>
  <v-dialog
    :model-value="modelValue"
    persistent
  >
    <FloatingContainer>
      <FormHeader
        headline="Подтвердите действие"
        icon="mdi-alert-outline"
        class="[&_.icon-container]:bg-rose-400"
        severity="danger"
      />

      <FormRow>
        <slot />
      </FormRow>

      <FormRow spacing="large">
        <section class="flex items-center gap-2">
          <v-btn
            rounded
            text="Отмена"
            :loading="isLoading"
            variant="tonal"
            prepend-icon="mdi-close"
            @click="onCancelClick"
          />

          <v-btn
            rounded
            :prepend-icon="confirmBtnIcon"
            :text="confirmBtnLabel"
            :color="severity"
            :loading="isLoading"
            variant="tonal"
            @click="$emit('confirm')"
          />
        </section>
      </FormRow>
    </FloatingContainer>
  </v-dialog>
</template>

<script setup lang="ts">
import FormRow from '@/components/layout/FormRow.vue';
import FormHeader from '@/components/layout/FormHeader.vue';
import FloatingContainer from '@/components/layout/FloatingContainer.vue';

type ConfirmationDialogProps = {
  modelValue: boolean;
  isLoading: boolean;
  confirmBtnLabel?: string;
  confirmBtnIcon?: string;
  severity?: 'error' | 'success';
}

const emit = defineEmits(['update:modelValue', 'cancel', 'confirm']);
withDefaults(defineProps<ConfirmationDialogProps>(), {
  confirmBtnLabel: 'Подтвердить',
  confirmBtnIcon: 'mdi-alert-outline',
  severity: 'error',
});

const onCancelClick = () => {
  emit('cancel');
  emit('update:modelValue', false);
};
</script>